/*
 * Copyright 2011 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package com.unitesk.requality.eclipse.editors.browser;

import java.util.UUID;

import org.eclipse.jface.viewers.ITreeContentProvider;
import org.eclipse.jface.viewers.Viewer;

import com.unitesk.requality.nodetypes.Document;
import com.unitesk.requality.nodetypes.Location;

final class ReqMarkerOutlineContentProvider implements
        ITreeContentProvider {

    @Override
    public void inputChanged(Viewer viewer, Object oldInput, Object newInput) {
    }

    @Override
    public void dispose() {
    }

    @Override
    public boolean hasChildren(Object element) {
        return getChildren(element).length>0;
    }

    @Override
    public Object getParent(Object element) {
        return null;
    }

    @Override
    public Object[] getElements(Object inputElement) {
        return getChildren(inputElement);
    }

    @Override
    public Object[] getChildren(Object parentElement) {
        if (parentElement instanceof Document) {
            Document doc = (Document) parentElement;
            UUID[] locationUUIDs = doc.getLocations().toArray(new UUID[0]);
            Object[] result = new Object[locationUUIDs.length];
            for (int i = 0; i < result.length; i++) {
                Location loc = doc.getLocation(locationUUIDs[i].toString());
                if(loc!=null) {
                    result[i]=loc;
                } else {
                    result[i]="missing: "+locationUUIDs[i].toString();
                }
            }
            return result;
        }
        if (parentElement instanceof Location) {
            return new Object[]{};
        }
        if (parentElement instanceof String) {
            return new Object[]{};
        }
        return null;
    }
}