package com.unitesk.requality.eclipse.handlers;

import org.eclipse.core.commands.AbstractHandler;
import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;

import com.unitesk.requality.core.TreeNode;
import com.unitesk.requality.eclipse.Activator;
import com.unitesk.requality.eclipse.ui.cnf.RequalityCNF;
import com.unitesk.requality.nodetypes.Comment;
import com.unitesk.requality.tools.RequalityCLI;

public class CreateCommentHandler extends AbstractHandler {

    @Override
    public Object execute(ExecutionEvent event) throws ExecutionException {
        TreeNode tn = (TreeNode) RequalityCNF.getSelectedNode();
        if(!tn.canBeParentOf(Comment.TYPE_NAME)){
            if(tn.getType().equals(Comment.TYPE_NAME))
                tn = tn.getParent();
            else
                return null;
        }
        String id = RequalityCLI.getNextId(tn, Comment.TYPE_NAME, Comment.TYPE_NAME + " ");
        tn.getTreeDB().startTransaction("Create Comment");
        Comment tc = (Comment) tn.createChild(id,
                Comment.TYPE_NAME);
        tc.saveAttributes();
        tn.getTreeDB().commit();
        Activator.getDefault().setActiveNode(tc, Comment.TYPE_NAME);
        return null;
    }

    @Override
    public boolean isEnabled() {
        TreeNode node = RequalityCNF.getSelectedNode();
        if (node.getType().equals(Comment.TYPE_NAME))
            return true;
        return node.canBeParentOf("Comment");
    }

}
