package com.unitesk.requality.eclipse.handlers;

import org.eclipse.core.commands.AbstractHandler;
import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.ui.PlatformUI;

import com.unitesk.requality.core.TreeNode;
import com.unitesk.requality.eclipse.Activator;
import com.unitesk.requality.eclipse.ui.cnf.RequalityCNF;
import com.unitesk.requality.nodetypes.TestPurpose;

public class DeleteTestPurposeHandler extends AbstractHandler {

    @Override
    public Object execute(ExecutionEvent event) throws ExecutionException {
        TestPurpose node = (TestPurpose) RequalityCNF.getSelectedNode();
        TreeNode parent = node.getParent();
        if (!MessageDialog.openConfirm(PlatformUI.getWorkbench()
                .getActiveWorkbenchWindow().getShell(), "Delete Test Purpose",
                "Delete selected Test Purpose?")) {
            return null;
        }
        node.getTreeDB().startTransaction("Remove Test Purpose");
        node.delete();
        node.getTreeDB().commit();
        if (parent != null)
            Activator.getDefault().setActiveNode(parent, parent.getType());
        return null;
    }

    @Override
    public boolean isEnabled() {
        TreeNode node = RequalityCNF.getSelectedNode();
        if (node == null) {
            return false;
        }
        if (!node.getType().equals(TestPurpose.TYPE_NAME)) {
            return false;
        }
        return true;
    }

}
