/*
 * Copyright 2011 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package com.unitesk.requality.nodetypes;

import java.util.ArrayList;
import java.util.List;
import java.util.UUID;

import com.unitesk.requality.core.TreeDB;
import com.unitesk.requality.core.TreeNode;

public class Comment extends TreeNode {

    public static final String TYPE_NAME = "Comment";
    public static final String ATTR_AUTHOR = "_author";

    public Comment() {
        super(null, null);
    }

    public Comment(TreeDB db, UUID uuid) {
        super(db, uuid);
    }

    @Override
    public String toString() {
        return getId();
    }

    private static List<String> possparents=new ArrayList<String>();
    private static List<String> posschildren=new ArrayList<String>();
    static{
        possparents.add(TestPurpose.TYPE_NAME);
        possparents.add(Requirement.TYPE_NAME);
    }

    @Override
    protected List<String> possibleParents() {
        return possparents;
    }

    public boolean isCopyable(){
        return true;
    }

    @Override
    protected List<String> possibleChildren() {
        return posschildren;
    }
}
