/*
 * Copyright 2009-2011 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.unitesk.requality.tools;

import java.util.Iterator;
import java.util.LinkedList;

import com.unitesk.requality.core.TreeNode;

public class DeepFirstTreeWalker extends TreeWalker {
    public DeepFirstTreeWalker(TreeNode startNode) {
        super(startNode);
    }

    @Override
    public Iterator<TreeNode> iterator() {
        return new Iterator<TreeNode>() {
            private LinkedList<TreeNode> stack = new LinkedList<TreeNode>();
            {
                stack.push(getStart());
            }

            @Override
            public boolean hasNext() {
                return !stack.isEmpty();
            }

            @Override
            public TreeNode next() {
                TreeNode result = stack.pop();
                for (int i = result.sizeChildren() - 1; i >= 0; i--) {
                    stack.push(result.getChild(i));
                }
                return result;
            }

            @Override
            public void remove() {
                throw new UnsupportedOperationException();
            }
        };
    }

}
